var database = {
    db : null,
    version: "1",
    development: true,
    queries: new Array(),
    config : {
        name : "calculadoragestacional",
        version : "1.0",
        title : "Calculadora Gestacional DB",
        size : 3 * 1024 * 1024
    },
    data : new Array(),
    initialize : function(callback) {

        if (!window.openDatabase) {
            console.log('error: database not supported');
            return false;
        }

        this.createDatabase();
        this.success(callback);
        this.createTables();
        //this.isUpdated();
    },
    success: function(callback) {
        var self = this;
        function runCallback() {
            if (self.isReady()) {
                clearInterval(timeout);
                console.log('info: database is ready!');
                callback();
            } else {
                console.log('info: waiting for the database to be ready...');
            }
        }

        timeout = setInterval(runCallback, 300);
    },
    list: function(tabela, callback, order_by) {

        var sqlString = "select * from " + tabela ;
        if(order_by!=undefined){
            sqlString += " order by "+ order_by +" ";
        }
        this.runSQL(sqlString, [], callback);
    },
    insertUsuario: function(values, callback) {
        var sqlString = 'REPLACE INTO usuario (id, email, estado, registro, regiao_id, processado, ativo, global_id, uuid, acessos, aplicativo, conselho, nascimento, outros) VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?) ';
        this.runSQL(sqlString, values, callback);
    },
    updateDatabase: function() {
    },
    loadData : function() {
        var self = this;
        $.each(calculadoraGestacionalDB, function(tabela, dados) {
            $.each(dados, function(index, arraySQL) {
                self.insertData(tabela, index, arraySQL);
            });
        });
    },
    insertData : function(table, index, arraySQL) {

        var fields = new Array(), values = new Array();
        $.each(arraySQL, function(field, value) {
            fields.push(field);
            values.push(addslashes(value));
        });

        this.runSQL('REPLACE INTO '+ table +' ('+ fields.join(', ') +') VALUES ('+ '"' + values.join('", "') + '"' +')');
    },
    createDatabase : function() {
        this.db = window.openDatabase(this.config.name, this.config.version,
                this.config.title, this.config.size);
    },
    createTables : function() {

       this.runSQL("CREATE TABLE IF NOT EXISTS usuario (id INTEGER unique, regiao_id, email, processado BOOLEAN, ativo BOOLEAN, global_id, uuid, acessos, estado, registro)");
       this.runSQLSemEmpilhar('ALTER TABLE usuario ADD registro');
       this.runSQLSemEmpilhar('ALTER TABLE usuario ADD estado');
       this.runSQLSemEmpilhar('ALTER TABLE usuario ADD aplicativo');
       this.runSQLSemEmpilhar('ALTER TABLE usuario ADD conselho');
       this.runSQLSemEmpilhar('ALTER TABLE usuario ADD nascimento');
       this.runSQLSemEmpilhar('ALTER TABLE usuario ADD outros');
       this.runSQL("CREATE TABLE IF NOT EXISTS acesso (id INTEGER unique PRIMARY KEY, funcao, data_acesso, processado BOOLEAN default false, global_id INTEGER)");
    },
    createTableQuery : function() {

    },
    runSQL : function(sqlString, values, callback, errorHandler) {
        var self = this;
        var sqlStringID = self.registerQuery(sqlString, 0);
        this.db.transaction(function(tx) {
            tx.executeSql(sqlString, values, function(tx, res) {
                self.runSQLCallback(tx, res, callback, sqlStringID);
            }, errorHandler);
            //console.log("query: " + sqlString);
        });
    },
    runSQLSemEmpilhar: function(sqlString, values, callback, errorHandler) {
        this.db.transaction(function(tx) {
            tx.executeSql(sqlString, values, function(tx, res) {
                if(callback!=undefined){
                    callback(tx, res);
                }
            }, errorHandler);
            //console.log("query: " + sqlString);
        });
    },
    runSQLCallback: function(tx, res, callback, sqlStringID) {
        //console.log('success: query #' + sqlStringID);
        this.updateQuery(sqlStringID, 1);
        if(callback != undefined){
            callback(tx, res);
        }
    },
    registerQuery: function(sqlString, status) {
        var arrayEntry = {'sql': sqlString, 'status': status};
        var len = this.queries.push(arrayEntry);
        return len-1;
    },
    updateQuery: function(sqlStringID, status) {
        if(this.queries[sqlStringID] != undefined){
            this.queries[sqlStringID].status = status;
        }
    },
    isReady: function() {
        var self = this;
        var ready = true;
        $.each(self.queries, function(index, arrayEntry) {
            if(arrayEntry.status!=undefined && arrayEntry.status!=1) {
                ready = false;
                return false;
            }
        });
        return ready;
    }
};

function addslashes( str ) {
    return (str + '').replace(/[\\"']/g, '\\$&').replace(/\u0000/g, '\\0');
}

Array.prototype.insert = function (index, item) {
    this.splice(index, 0, item);
};
