var app = {
    config: {
        cadastro_obrigatorio : true,
        url_cadastro_usuario: 'http://painel.telessaude.sisqualis.com.br/accounts/login/',
        url_acesso_usuario: 'http://painel.telessaude.sisqualis.com.br/analytics/acesso/',
        aplicativo: 'Calculadora Gestacional',

        usuario_status: false,
        usuario: {}
    },
    process : {
        refeicaoID : null,
        alimentos: [],
        regiaoID: null
    },
    // Application Constructor
    initialize: function() {
        var self = this;
        this.bindEvents();

        $(function() {
            self.validacaoFormularioCadastro();
            self.selectRegiao();
            self.selectEstado();
            self.selectConselho();
            self.bindTipoCalculo();
            self.bindValidateInputNumber();
        });
    },
    bindTipoCalculo: function() {
        $('#sq-tipo-calculo input[name="tipocalculo"]').each(function() {
            $(this).on('click', function(){
                app.resetarConteudo();
                $('.sq-box-datas').hide();
                $($(this).attr('data:box-data')).show();
                $($(this).attr('data:box-complemento')).show();
                $('#sq-tipo-calculo [data-rel="popup"]').hide();
                $($(this).attr('data:btn-popup-info')).show();
                $('.sq-btn-calcular').button( 'enable' );
            });
        });
    },
    bindValidateInputNumber : function() {
        $('input[type="number"]', '#sq-calculo-por-ecografia .sq-tabela-resultado').forceNumericOnly();
    },
    splashHide: function() {
        setTimeout(function() {
            try {
                navigator.splashscreen.hide();
            } catch (e) {
            }
        }, 100);
    },
    splashShow: function() {
        setTimeout(function() {
            try {
                navigator.splashscreen.show();
            } catch (e) {
            }
        }, 100);
    },
    bindEvents: function() {
        var self = this;
        document.addEventListener('deviceready', self.onDeviceReady, false);
        document.addEventListener("menubutton", self.onMenuKeyDown, false);
        $(document).on("click", "#desabilitar-mensagem-inicial", self.desabilitarMensagemInicial);
    },
    onDeviceReady: function() {
        var arrVersion = window.device.version.split('.');
        if (window.device.platform == "iOS" && arrVersion[0] * 1 >= 7) {
            $("body").addClass('ios7');
            $("#header .ui-btn, #header .sq-logo-brasil").css("margin-top", "19px");
            $('.ui-content', app.getActivePage()).css("margin-top", "20px");
        }

        setTimeout(function() {
            app.splashHide();
        }, 4000);

        document.addEventListener('backbutton', function(e){
           e.preventDefault();
           if ($.mobile.navigate.history.activeIndex == 0) {
               navigator.app.exitApp();
           } else {
               navigator.app.backHistory();
           }
        }, false);
    },
    onMenuKeyDown: function() {
        $('#menu').panel("toggle");
    },
    validacaoFormularioCadastro: function() {
        $(function() {
            (function ($) {
                $.extend($.validator.messages, {
                    required: "Este campo é obrigatório",
                    email: "Por favor, insira o e-mail válido",
                    number: "Insira apenas dígitos"
                });
            }(jQuery));
            $(".sq-form-cadastro").each(function() {
                $(this).validate({
                    errorClass:'ui-error',
                    rules: {
                        regiao: "required",
                        registro: "number"
                    },
                    errorPlacement: function(error, element) {
                        if (element.is('select')) {
                            error.insertAfter($(element).parent().parent().parent());
                        } else {
                            error.insertAfter($(element).parent());
                        }
                    },
                    submitHandler: function( form ) {
                        app.saveUsuario();
                    }
                });
            });
            $('input[name="registro"]', '.sq-form-cadastro').forceNumericOnly();
        });
    },
    saveUsuario: function() {

        var self = this;
        var formData = {};
        $.each($('.sq-form-cadastro', self.getActivePage()).serializeArray(), function(_, kv) {
            formData[kv.name] = kv.value;
        });

        app.setUsuarioStatus(true);

        var uuid = '', global_id = null, acessos=1;

        if (app.config.usuario.acessos != undefined) {
            acessos = app.config.usuario.acessos;
        }
        if (app.config.usuario.global_id != undefined) {
            global_id = app.config.usuario.global_id;
        }

        try {
            uuid = device.uuid;
        } catch (e) {
        }

        var values = [1, formData.email, formData.estado,
                        formData.registro, formData.regiao_id, false,
                        true, global_id, uuid, acessos, app.config.aplicativo, formData.conselho, formData.nascimento, formData.outros];
        database.insertUsuario(values, app.loadsaveUsuarioOnline);

        return false;
    },
    goToHome: function() {
        var pageActive = $.mobile.navigate.history.getActive().hash;
        var destino = "#inicio";
        if (localStorage.getItem('apresentacaoExibida') || pageActive == '#configuracao') {
            destino = "#calcular";
        }
        this.goTo(destino);
    },
    getActivePage: function() {
        return $(':mobile-pagecontainer').pagecontainer('getActivePage');
    },
    goTo: function(pagina) {
        $.mobile.navigate(pagina);
    },
    setUsuarioStatus: function(status) {
        this.config.usuario_status = status;
    },
    setUsuario: function(row) {
        app.config.usuario = row;

        var context = $('#configuracao .sq-form-cadastro');

        $('[name="registro"]', context).val(row.registro);
        $('[name="email"]', context).val(row.email);
        $('[name="estado"]', context).val(row.estado);
        $('[name="conselho"]', context).val(row.conselho);
        $('[name="nascimento"]', context).val(row.nascimento);
        $('[name="outros"]', context).val(row.outros);
        $('#regiao_id', context).val(row.regiao_id);

        try {
            $('[name="estado"]', context ).selectmenu("refresh", true);
            $('[name="conselho"]', context ).selectmenu("refresh", true);
        } catch (e) {
        }

    },
    getUsuarioStatus: function() {
        return this.config.usuario_status;
    },
    loadsaveUsuarioOnline: function() {
        database.runSQL("SELECT * FROM usuario WHERE id=1", [], sendUsuario );
        function sendUsuario(tx, res) {
            if(res.rows.length>0 && res.rows.item(0)!=undefined) {
                var row = res.rows.item(0);
                row.aplicativo = app.config.aplicativo;
                app.setUsuario(row);
                app.setProcess('regiaoID', row.regiao_id);
                app.setUsuarioStatus(Boolean(row.ativo));

                if (row.processado != 'true') {
                    $.ajax({
                        type: "POST",
                        url: app.config.url_cadastro_usuario,
                        cache: false,
                        data: row,
                        success: function (result) {
                            // update user
                            if (result.ok != undefined && result.ok) {
                                app.alert('Realizado com sucesso!', 'Sucesso!');
                                var global_id = result.id;
                                app.config.usuario.global_id = global_id;
                                database.runSQL("UPDATE usuario SET processado=? , global_id=? where id=?", [true, global_id , 1], function(tx, res){
                                    app.setUsuarioStatus(true);
                                });
                            } else {
                                app.alert('Erro ao salvar informações cadastrais no servidor - nova tentativa será realizada na próxima vez em que o app for aberto.');
                            }
                        },
                        error: function (request, error) {
                            app.alert('Erro ao salvar informações cadastrais no servidor - nova tentativa será realizada na próxima vez em que o app for aberto.');
                            console.log("erro: " + error);
                        }
                    });
                }
                app.goToHome();
            } else if (app.config.cadastro_obrigatorio) {
                app.setUsuarioStatus(false);
                app.goTo("#cadastro");
            } else {
                app.goToHome();
            }
        }

        return false;
    },
    addAcesso: function(funcao) {
        setTimeout(function() {
            database.runSQL("INSERT INTO acesso (funcao, data_acesso) VALUES (?, ?)", [funcao, dateNow()], app.sendUsuarioAcesso);
        }, 350);
    },
    sendUsuarioAcesso: function() {
        database.runSQL("SELECT * FROM acesso WHERE processado != 'true'", [], function(tx, res) {
            if (_.isUndefined(app.config.usuario.global_id)) {
                return false;
            }
            if (res.rows.length>0) {
                for (i=0; i<res.rows.length; i++) {
                    var row = res.rows.item(i);

                    $.ajax({
                        type: "POST",
                        url: app.config.url_acesso_usuario,
                        cache: false,
                        data: {
                            local_id: row.id,
                            usuario: app.config.usuario.global_id,
                            funcao: row.funcao,
                            data_acesso: row.data_acesso
                        },
                        success: function (result) {
                            if (result.ok != undefined && result.ok) {
                                console.log(result);
                                var global_id = result.id;
                                var local_id = result.local_id;
                                database.runSQL("UPDATE acesso SET processado=? , global_id=? where id=?", [true, global_id , local_id], function(tx, res){
                                    // update acesso
                                });
                            } else {
                                console.log('Erro ao salvar informações');
                            }
                        },
                        error: function (request, error) {
                            console.log("erro: " + error);
                        }
                    });
                }
            }
        });
    },
    initJQM: function() {
        var self = this;

        self.initDB();

        $.mobile.defaultPageTransition = 'none';
        $.mobile.allowCrossDomainPages = true;

        $.mobile.loader.prototype.options.text = "Carregando...";
        $.mobile.loader.prototype.options.textVisible = true;
        $.mobile.loader.prototype.options.theme = "b";
        $.mobile.loader.prototype.options.html = "";

        $( document ).on( "pagecreate", function(e, data ) {
            $( "body > [data-role='panel']" ).panel();
            $( "body > [data-role='panel'] [data-role='listview']" ).listview();
            $( "body > [data-role='panel'] [data-role='collapsible']" ).collapsible();
            $( "[data-role='header']" ).toolbar({tapToggle:false});
            $( "body > [data-role='header'] [data-role='navbar']" ).navbar();
        });

        $(document).on("pagechange", function(e) {
            $( "#menu" ).panel( "close" );
            app.hideLoader();
            var activeIndex = $.mobile.navigate.history.activeIndex;
            var ghostPages = ['#loading', '#cadastro', '#inicio'];
            var pageInitial = $.mobile.navigate.history.stack[0].hash;
            if (_.contains(ghostPages, pageInitial) && window.location.hash != pageInitial) {
                $.mobile.navigate.history.stack.reverse().pop();
                $.mobile.navigate.history.activeIndex = activeIndex - 1;
            }

            if ($.mobile.navigate.history.activeIndex == 0) {
                $('[data-rel="back"]').hide();
            }
        });

        $(document).on("pageshow", '#calcular', function(e) {
            app.initDatepicker();
        });

        $(document).on( "pagebeforechange", function( e, data ) {

            if ( typeof data.toPage === "string" ) {

                var u = $.mobile.path.parseUrl( data.toPage );
                var pageSelector = u.hash.replace(/\?.*$/, "");

                if (pageSelector=='#cadastro' || pageSelector=='#inicio') {
                    $('a[href=#menu]').hide();
                } else {
                    $('[data-rel="back"]').show();
                    $('a[href=#menu]').show();
                }

                var funcao = '';
                if (u.hash!='') {
                    funcao = u.hash.replace('#','');
                } else if (u.filename!='') {
                    funcao = u.filename.replace('.html', '');
                }

                if (self.config.cadastro_obrigatorio) {
                    if (self.getUsuarioStatus() != true) {
                        if (database.isReady()) {
                            if (pageSelector!='#cadastro') {
                                app.goTo('#cadastro');
                                e.preventDefault();
                            }
                        }
                    }
                }
                self.addAcesso(funcao);

            }
        });
    },
    showLoader : function() {
        $.mobile.loading('show', {
            text : 'Carregando...',
            textVisible : true,
            theme : 'b',
            textonly : false,
            html : ''
        });

    },
    hideLoader : function() {
        $.mobile.loading('hide');
    },
    setProcess: function(index, value) {
        this.process[index] = value;
    },
    setProcessRegiao: function(selRegiaoID) {
        if (selRegiaoID != undefined) {
            this.setProcess('regiaoID', $('option:selected', selRegiaoID).attr('id'));
        } else {
            this.setProcess('regiaoID', $('.sq-select-regiao option:selected').attr('id'));
        }
        app.carregaConteudos();
    },
    setProcessEstado: function(selEstadoID) {
        var regiaoID = $('option:selected', selEstadoID).attr('data:regiao');

        $('#regiao_id', $('.sq-select-estado').closest('form')).val(regiaoID);

        this.setProcess('regiaoID', regiaoID);
        this.carregaConteudos();
    },
    calcular : function() {
        $('#sq-resultado-calculo').show();
        var tipo_calculo = $('[name="tipocalculo"]:checked').val();
        var dpp = new Date();
        var boxDatas, dias = 0, semanas;
        if (tipo_calculo == 'dum') {
            boxDatas = '#sq-calculo-por-dum';
            var dataConsulta = parseDate($('input[name="data-consulta"]', boxDatas).val());
            var dum = parseDate($('input[name="dum"]', boxDatas).val());
            dias = diferencaEmDias(dum, dataConsulta);
            dpp = dum.addDays(280);
        } else if (tipo_calculo == 'eco') {
            boxDatas = '#sq-calculo-por-ecografia';
            var dataConsulta = parseDate($('input[name="data-consulta"]', boxDatas).val());
            var dataEcografia = parseDate($('input[name="data-ecografia"]', boxDatas).val());
            var semanasEcografia = parseInt($('input[name="ecografia-semanas"]', '#sq-calculo-por-ecografia-complemento .sq-tabela-resultado').val()) || 0;
            var diasEcografia = parseInt($('input[name="ecografia-dias"]', '#sq-calculo-por-ecografia-complemento .sq-tabela-resultado').val()) || 0;
            var idadeGestacionalEcografia = parseInt(getDias(semanasEcografia, diasEcografia)) || 0;
            dpp = dataEcografia.addDays(280 - idadeGestacionalEcografia);
            dias = diferencaEmDias(dataEcografia, dataConsulta) + idadeGestacionalEcografia;
        }

        semanas = getSemanas(dias);

        xdateDpp = new XDate(dpp);

        $('#sq-res-dias').html(semanas.dias);
        $('#sq-res-semanas').html(semanas.semanas);

        $('#sq-alert-41semanas').hide();
        if (semanas.semanas > 41) {
            $('#sq-alert-41semanas').show();
        }
        if (semanas.semanas > 45 || semanas.semanas < 0) {
            $('#sq-resultado-calculo').hide();
            app.alert('Dados inválidos!', 'Atenção!');
        }

        $('#sq-res-dia').html(dpp.getUTCDate());
        $('#sq-res-mes').html(xdateDpp.toString("MMM"));
        $('#sq-res-ano').html(dpp.getUTCFullYear());
    },
    resetarResultado: function() {
        $('.sq-calculadora-resultado').html('-');
    },
    resetarConteudo: function() {
        $('.sq-box-datas').hide();
        $('#sq-resultado-calculo').hide();
        $('#sq-tipo-calculo .sq-btn-info').hide();
        $('#sq-alert-41semanas').hide();
        $('#sq-alert-info-erroEcografia').hide();

        $('.input-data input[type="date"]').mobipick('updateDate', new XDate());
        $('.input-data input[type="date"]').mobipick('updateDateInput');

        $('input[type="number"]', '#sq-calculo-por-ecografia .sq-tabela-resultado').val("");
        $('.sq-btn-calcular').button( {inline: true, mini: true, shadow: false, theme: "s", enhanced: true} );
        $('.sq-btn-calcular').button( 'disable' );
    },
    resetar: function() {
        $('.ui-radio input').attr('checked', false);
        $('.ui-radio input').checkboxradio("refresh");
        this.resetarConteudo();
    },
    showInfoErroEcografia : function() {

        var semanas=0, dias=0, erro='', periodo='';
        $('#sq-alert-info-erroEcografia').hide();

        semanas = $('input[name="ecografia-semanas"]', '#sq-calculo-por-ecografia-complemento .sq-tabela-resultado').val();
        dias = $('input[name="ecografia-dias"]', '#sq-calculo-por-ecografia-complemento .sq-tabela-resultado').val();

        if (dias > 6) {
            alert('Insira no máximo 6 dias ou adicione o número de semanas correspondente.');
            $('input[name="ecografia-dias"]', '#sq-calculo-por-ecografia-complemento .sq-tabela-resultado').val('');
        }

        if (semanas >= 7 && semanas <= 9) {
            periodo = 'entre 6-9 semanas';
            erro = '± 3 dias';
        } else if (semanas > 9 && semanas <= 12) {
            periodo = 'entre 9-12 semanas';
            erro = '± 5 dias';
        } else if (semanas > 12 && semanas <= 18) {
            periodo = 'entre 12-18 semanas';
            erro = '± 7 dias';
        } else if (semanas > 18 && semanas <= 24) {
            periodo = 'entre 18-24 semanas';
            erro = '± 10 dias';
        } else if (semanas > 24 && semanas <= 30) {
            periodo = 'entre 24-30 semanas';
            erro = '± 2 semanas';
        } else if (semanas > 30 ) {
            periodo = 'a partir de 30 semanas';
            erro = '± 2-4 semanas';
        }

        if (erro != '') {
            $('#sq-ecografia-erro').html(erro);
            $('#sq-ecografia-periodo').html(periodo);
            $('#sq-alert-info-erroEcografia').show();
        }
        this.resetarResultado();
    },
    includeContents : function() {
        $('.content-include').each(function() {
            $(this).load($(this).attr('data:content'));
        });
    },
    initDB: function() {
        setTimeout(function() {
            $.mobile.loading('show');
        }, 100);
        database.initialize(app.loadDataFromDB);
    },
    loadDataFromDB: function() {
        app.loadsaveUsuarioOnline();
        setTimeout(function() {
            $.mobile.loading('hide');
        }, 1);
    },
    selectRegiao: function() {
        var container = 'select.sq-select-regiao';

        _.each(calculadoraGestacionalDB.regiao, function(obj, index) {
            $(container).append('<option id="'+ obj.id +'" value="'+ obj.nome +'"> '+  obj.nome +' </option>');
        });
    },
    selectEstado: function() {
        var container = 'select.sq-select-estado';

        _.each(calculadoraGestacionalDB.estado, function(obj, index) {
            $(container).append('<option id="'+ obj.id +'" value="'+ obj.nome +'" data:regiao="'+ obj.regiao +'"> '+  obj.nome +' </option>');
        });
    },
    selectConselho: function() {
        var container = 'select.sq-select-conselho';

        _.each(calculadoraGestacionalDB.conselho, function(obj, index) {
            $(container).append('<option id="'+ obj.id +'" value="'+ obj.id +'"> '+ obj.id + ' ' +  obj.nome +' </option>');
        });
    },
    initDatepicker: function() {
        var picker = $(".input-data input", document);
        $(".input-data input").each(function() {
            $(this).click(function(e){
                $(this).focus();
            });
        });

        picker.mobipick({
            locale : "pt-br"
        });
    },
    validateNumber : function() {
        if ($(this).val() < 0) {
            $(this).val(0);
        }
    },
    changeTypeField: function(campo, tipo) {
        $(campo).attr('type', tipo);
    },
    desabilitarMensagemInicial: function() {
        localStorage.setItem('apresentacaoExibida', true)
    }
};

var databaseIsUpdate = false;

$(document).on("mobileinit", function(){
    app.initJQM();
});

function pre(data){
    console.log(data);
}

jQuery.fn.outerHTML = function(s) {
    return s
        ? this.before(s).remove()
        : jQuery("<p>").append(this.eq(0).clone()).html();
};

function parseDate(str) {
    var mdy = str.split('-');
    return new Date(mdy[0], mdy[1]-1, mdy[2]);
}

function diferencaEmDias(primeira, segunda) {
    return Math.ceil((segunda-primeira)/(1000*60*60*24));
}

function getSemanas(dias) {
    return {
        semanas : Math.floor(dias / 7),
        dias : parseInt(dias % 7)
    };
}

function getDias(semanas, dias) {
    return (parseInt(semanas) * 7) + parseInt(dias);
}

Date.prototype.addDays = function(days) {
    var dat = new Date(this.valueOf());
    dat.setDate(dat.getDate() + days);
    return dat;
};
app.alert = function (mensagem, titulo) {
    if (titulo==undefined) {
        titulo = 'Alerta!';
    }
    try {
        navigator.notification.alert(mensagem, null, titulo, 'Ok');
    } catch(e) {
        alert(mensagem);
    }
}

// Numeric only control handler
jQuery.fn.forceNumericOnly = function() {
    return this.each(function() {
        $(this).keydown(function(e) {
            var key = e.charCode || e.keyCode || 0;
            return ( key == 8 || key == 9 || key == 13 || key == 46 || key == 110 || key == 190 || (key >= 35 && key <= 40) || (key >= 48 && key <= 57) || (key >= 96 && key <= 105));
        });
    });
};
function dateNow() {
    var d = new Date,
    dformat = [d.getDate(), d.getMonth()+1, d.getFullYear()].join('/')+' '+
              [d.getHours(), d.getMinutes(), d.getSeconds()].join(':');
    return dformat;
}

// Corrige bug da toolbar fixa no iOS
// Ela se esconde quando foca em algum input, e quando voltava
// ficava na posição errada. O script abaixo conserta este problema
$(document).on('blur', 'input, textarea, select', function() {
    document.body.scrollLeft = 0;
});
