XDate.locales['fr'] = {
  monthNames: ['Janvier','Février','Mars','Avril','Mai','Juin','Juillet','Août','Septembre','Octobre','Novembre','Décembre'],
  monthNamesShort: ["Janv","Févr","Mars","Avr","Mai","Juin","Juil","Août","Sept","Oct","Nov","Déc"],
  dayNames: ['Dimanche','Lundi','Mardi','Mercredi','Jeudi','Vendredi','Samedi'],
  dayNamesShort: ['Dim.','Lun.','Mar.','Mer.','Jeu.','Ven.','Sam.'],
  dateFormat: "dddd, d MMMM yyyy",
  dateFormatMonth: "MMMM yyyy",
  dateFormatYear: "yyyy",
  ok: "Accepter",
  cancel: "Annuler"
};
XDate.locales['de'] = {
  monthNames: ["Januar","Februar","März","April","Mai","Juni","Juli","August","September","Oktober","November","Dezember"],
  monthNamesShort: ["Jan","Feb","Mär","Apr","Mai","Jun","Jul","Aug","Sep","Okt","Nov","Dez"],
  dayNames: ["Sonntag","Montag","Dienstag","Mittwoch","Donnerstag","Freitag","Samstag"],
  dayNamesShort: ["So","Mo","Di","Mi","Do","Fr","Sa"],
  dateFormat: "dddd, d.MMMM yyyy",
  dateFormatMonth: "MMMM yyyy",
  dateFormatYear: "yyyy",
  ok: "\u00dcbernehmen",
  cancel: "Abbrechen"
};
XDate.locales['en'] = {
  monthNames: ["January","February","March","April","May","June","July","August","September","October","November","December"],
  monthNamesShort: ["Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec"],
  dayNames: ["Sunday","Monday","Tuesday","Wednesday","Thursday","Friday","Saturday"],
  dayNamesShort: ["Sun","Mon","Tue","Wed","Thu","Fri","Sat"],
  dateFormat: "dddd, MMMM d, yyyy",
  dateFormatMonth: "MMMM yyyy",
  dateFormatYear: "yyyy",
  ok: "Accept",
  cancel: "Cancel"
};
XDate.locales['he'] = {
  monthNames: ["ינואר","פברואר","מרץ","אפריל","מאי","יוני","יולי","אוגוסט","ספטמבר","אוקטובר","נובמבר","דצמבר"],
  monthNamesShort: ["ינואר","פבר","מרץ","אפר","מאי","יוני","יולי","אוג","ספט","אוק","נוב","דצ"],
  dayNames: ["ראשון","שני","שלישי","רביעי","חמישי","שישי","שבת"],
  dayNamesShort: ["א","ב","ג","ד","ה","ו","שבת"],
  dateFormat: "dddd, MMMM d, yyyy",
  dateFormatMonth: "MMMM yyyy",
  dateFormatYear: "yyyy",
  ok: "אישור",
  cancel: "ביטול"
};
XDate.locales['it'] = {
  monthNames: ["Gennaio","Febbraio","Marzo","Aprile","Maggio","Giugno","Luglio","Agosto","Settembre","Ottobre","Novembre","Dicembre"],
  monthNamesShort: ["Gen","Feb","Mar","Apr","Mag","Giu","Lug","Ago","Set","Ott","Nov","Dic"],
  dayNames: ["Domenica","Lunedì","Martedì","Mercoledì","Giovedì","Venerdì","Sabato"],
  dayNamesShort: ["Dom","Lun","Mar","Mer","Gio","Ven","Sab"],
  dateFormat: "dddd, d MMMM yyyy",
  dateFormatMonth: "MMMM yyyy",
  dateFormatYear: "yyyy",
  ok: "Assumi",
  cancel: "Annulla"
};
XDate.locales['es'] = {
  monthNames: ["Enero","Febrero","Marzo","Abril","Mayo","Junio","Julio","Agosto","Septiembre","Octubre","Noviembre","Diciembre"],
  monthNamesShort: ["Ene","Feb","Mar","Abr","May","Jun","Jul","Ago","Sep","Oct","Nov","Dic"],
  dayNames: ["Domingo","Lunes","Martes","Miércoles","Jueves","Viernes","Sábado"],
  dayNamesShort: ["Dom","Lun","Mar","Mié","Jue","Vie","Sáb"],
  dateFormat: "dddd, d 'de' MMMM 'de' yyyy",
  dateFormatMonth: "MMMM 'de' yyyy",
  dateFormatYear: "yyyy",
  ok: "Aplicar",
  cancel: "Cancelar"
};
XDate.locales['nl'] = {
  monthNames: ["Januari","Februari","Maart","April","Mei","Juni","Juli","Augustus","September","Oktober","November","December"],
  monthNamesShort: ["Jan","Feb","Mrt","Apr","Mei","Jun","Jul","Aug","Sep","Okt","Nov","Dec"],
  dayNames: ["Zondag","Maandag","Dinsdag","Woensdag","Donderdag","Vrijdag","Zaterdag"],
  dayNamesShort: ["Zo","Ma","Di","Wo","Do","Vr","Za"],
  dateFormat: "dddd, d MMMM yyyy",
  dateFormatMonth: "MMMM yyyy",
  dateFormatYear: "yyyy",
  ok: "Overnemen",
  cancel: "Annuleren"
};
XDate.locales['sv'] = {
  monthNames: ["Januari","Februari","Mars","April","Maj","Juni","Juli","Augusti","September","Oktober","November","December"],
  monthNamesShort: ["Jan","Feb","Mar","Apr","Maj","Jun","Jul","Aug","Sep","Okt","Nov","Dec"],
  dayNames: ["Söndag","Måndag","Tisdag","Onsdag","Torsdag","Fredag","Lördag"],
  dayNamesShort: ["Sö","Må","Ti","On","To","Fr","Lö"],
  dateFormat: "dddd, d MMMM yyyy",
  dateFormatMonth: "MMMM yyyy",
  dateFormatYear: "yyyy",
  ok: "Klar",
  cancel: "Avbryt"
};
XDate.locales['pt-br'] = {
  monthNames: ["Janeiro","Fevereiro","Março","Abril","Maio","Junho","Julho","Agosto","Setembro","Outubro","Novembro","Dezembro"],
  monthNamesShort: ["Jan","Fev","Mar","Abr","Mai","Jun","Jul","Ago","Set","Out","Nov","Dez"],
  dayNames: ["Domingo","Segunda-feira","Terça-feira","Quarta-feira","Quinta-feira","Sexta-feira","Sábado"],
  dayNamesShort: ["Dom","Seg","Ter","Qua","Qui","Sex","Sáb"],
  dateFormat: "dddd, d - MMMM - yyyy",
  dateFormatMonth: "MMMM yyyy",
  dateFormatYear: "yyyy",
  ok: "Ok",
  cancel: "Cancelar"
};
XDate.locales['hr'] = {
    monthNames: ["Siječanj","Veljača","Ožujak","Travanj","Svibanj","Lipanj","Srpanj","Kolovoz","Rujan","Listopad","Studeni","Prosinac"],
    monthNamesShort: ["Sij","Velj","Ožu","Tra","Svi","Lip","Srp","Kol","Ruj","Lis","Stu","Pro"],
    dayNames: ["Nedjelja","Ponedjeljak","Utorak","Srijeda","Četvrtak","Petak","Subota"],
    dayNamesShort: ["Ned","Pon","Uto","Sri","Čet","Pet","Sub"],
    dateFormat: "dddd, d. MMMM yyyy.",
    dateFormatMonth: "MMMM yyyy",
    dateFormatYear: "yyyy",
    ok: "Potvrdi",
    cancel: "Prekid"
};
XDate.locales['cs'] = {
  monthNames: ["ledna","února","března","dubna","května","června","července","srpna","září","října","listopadu","prosince"],
  monthNamesShort: ["Led","Úno","Bře","Dub","Kvě","Čer","Červ","Srp","Zář","Říj","Lis","Pro"],
  dayNames: ["Neděle","Pondělí","Úterý","Středa","Čtvrtek","Pátek","Sobota"],
  dayNamesShort: ["Ne","Po","Út","St","Čt","Pá","So"],
  dateFormat: "dddd, d. MMMM yyyy",
  dateFormatMonth: "MMMM yyyy",
  dateFormatYear: "yyyy",
  ok: "OK",
  cancel: "Zrušit"
};
